# How to contribute

First, thank you for reading this and considering contributing to the continued success of kurly!

If you haven't already, come find us in IRC ([#kurly](irc://chat.freenode.net/kurly) on freenode). We want you working on things you're excited about.

## Important resources

* [GitLab Issues](https://gitlab.com/davidjpeacock/kurly/issues) for general bug reports feature requests
* [Email](mailto:david.j.peacock@gmail.com) for security related bugs that require sensitivity
* [#kurly](irc://chat.freenode.net/kurly) IRC channel on Freenode

## How to help

We need contributors to a wide variety of things for kurly.  Examples include:

* Documentation - if you see a gap or error in any docs, please consider addressing this
* Test coverage - testing is something we're struggling with for kurly right now, and this needs all the help it can get
* Packaging - if you're able and willing to be a long-term maintainer of a particular package for your distribution or OS of course, please get in touch
* Bug fixes - please peruse the [GitLab Issues List](https://gitlab.com/davidjpeacock/kurly/issues); in particular, watch out for the tags 'help wanted', and 'good first issue'
* Features - we welcome features too - please feel free to discuss anything in advance on our IRC channel [#kurly](irc://chat.freenode.net/kurly) in order to coordinate efforts

## Guidelines

* We like small atomic commits.  Please structure your commits such that a single commit containing working code comes in as a pull request nice and clean; if you have multiple working commits please rebase your branch first before sending the pull request
* Commit messages must not be one-liners; structure them with a concise summary on the first line, followed by a multiline description of the purpose of the commit.  E.g.
```
add whizbang doohickey

This commit adds functionality to help with things
to do with the other thing that we also worked on before
```
* Make use of [GitLab keywords](https://docs.gitlab.com/ee/user/project/issues/automatic_issue_closing.html) in your commit messages to automatically link pull requests to issues
* When adding a new feature ie., adding a new commandline option, make sure to add documentation for the same in the [man page](doc/kurly.man) included in the project.

Thanks,
David Peacock
